//! Arg parsing
use super::*;

pub fn program_name() -> &'static str
{
    lazy_static::lazy_static!{
	static ref NAME: &'static str = Box::leak(std::env::args().next().unwrap().into_boxed_str());
    }

    &NAME[..]
}

#[inline] pub fn parse() -> ReportedResult<config::Config>
{
    parse_as_args(std::env::args().skip(1))
}

pub fn parse_as_args<T,I>(args: I) -> ReportedResult<config::Config>
where I: IntoIterator<Item=T>,
T: AsRef<str>
{
    let mut args = args.into_iter();
    
    while let Some(arg) = args.next() {
	let arg = arg.as_ref();
	
    }

    todo!()
}
